#!/bin/bash
# ******************************************************************************
# * FILE NAME: create_sd.sh
# *
# * DESCRIPTION:
# *  This script file parses the .out executables generated by the diagnostic
# *  makefile into SD card loadable files.
# *
# *  The script expects the board as a parameter. Out2rprc and MulitcoreImageGen
# *  can be set manually by environment variables $OUT2RPRC and 
# *  $MULTICOREIMAGEGEN, respectively. If not set, script will assume default
# *  location in $PDK_INSTALL_PATH/ti/boot/sbl/tools
# *
# *  Syntax:
# *      create_sd.sh [BOARD]
# *
# *  Example:
# *      create_sd.sh idkAM572x
#
# * Copyright (C) 2019, Texas Instruments, Inc.
# *****************************************************************************

board=$1

if [ $board = "evmAM335x" ]
then
    echo "Done! create_sd script not needed for $board!"
    exit 0
fi

if [ $board = "evmAM437x" ]
then
    echo "Done! create_sd script not needed for $board!"
    exit 0
fi

if [ $board = "idkAM437x" ]
then
    echo "Done! create_sd script not needed for $board!"
    exit 0
fi

if [ $board = "skAM437x" ]
then
    echo "Done! create_sd script not needed for $board!"
    exit 0
fi

if [ $board = "bbbAM335x" ]
then
    echo "Done! create_sd script not needed for $board!"
    exit 0
fi

if [ $board = "icev2AM335x" ]
then
    echo "Done! create_sd script not needed for $board!"
    exit 0
fi

if [ $board = "skAM335x" ]
then
    echo "Done! create_sd script not needed for $board!"
    exit 0
fi

if [ $board = "evmK2H" ]
then
    core_id=5
fi

if [ $board = "evmK2E" ]
then
    core_id=5
fi

if [ $board = "iceK2G" ]
then
    core_id=5
fi

if [ $board = "evmK2G" ]
then
    core_id=5
fi

if [ $board = "evmAM572x" ]
then
    core_id=8
fi

if [ $board = "evmAM571x" ]
then
    core_id=8
fi

if [ $board = "idkAM574x" ]
then
    core_id=8
fi

if [ $board = "idkAM572x" ]
then
    core_id=8
fi

if [ $board = "idkAM571x" ]
then
    core_id=8
fi

benchmarkdir=$PROC_SDK_INSTALL_PATH/demos/audio-benchmark-starterkit

if [ -d "$benchmarkdir/prebuilt-binaries" ]
then
	echo "Creating SD files for $board..."
else
	echo "Missing folder/files under $benchmarkdir/prebuilt-binaries"
	echo "Usage: ./create_sd.sh [BOARD]"
	echo     "Eg. ./create_sd.sh idkAM572x"
	exit
fi

sbl_sd=$PDK_INSTALL_PATH/ti/boot/sbl/binary/$board/spi/bin/MLO
if [ ! -f $sbl_sd ]
then
    echo 
	echo "Missing MLO built from bootloader source"
	echo "Not found in default location:" 
	echo "$PDK_INSTALL_PATH/ti/boot/sbl/binary/$board/mmcsd/bin/MLO"
	echo "Looking for pre-built binary...."
    sbl_sd=$PROC_SDK_INSTALL_PATH/prebuilt-sdcards/$board/sd_card_files/MLO
    if [ ! -f $sbl_sd ]
	then
	    echo 
	    echo "Missing prebuilt MLO"
	    echo "Not found in default location: "
	    echo "$PROC_SDK_INSTALL_PATH/prebuilt-sdcards/$board/sd_card_files/MLO"
	    echo "Change Directory to $PDK_INSTALL_PATH/ti/boot/sbl"
	    echo "Run gmake all BOARD=$board SOC=$SOC BOOTMODE=mmcsd"
            exit
    else
        echo Using MLO: $sbl_sd
	fi
else
    echo Using MLO: $sbl_sd
fi


out2rprc=$OUT2RPRC
if [ -z $out2rprc ]
then
	out2rprc=$PDK_INSTALL_PATH/ti/boot/sbl/tools/out2rprc/bin/out2rprc.exe
fi
if [ ! -f $out2rprc ]
then
	echo "Missing out2rprc!"
	echo     "Not found in default location: \$PDK_INSTALL_PATH/ti/boot/sbl/tools/out2rprc/bin/out2rprc.exe"
	echo     "Override default location by setting OUT2RPRC, eg:"
	echo         "export OUT2RPRC=$PDK_INSTALL_PATH/ti/boot/sbl/tools/out2rprc/bin/out2rprc"
	exit
else
	echo Using out2prc: $out2rprc
fi

multigen=$MULTICOREIMAGEGEN
if [ -z $multigen ]
then
	multigen=$PDK_INSTALL_PATH/ti/boot/sbl/tools/multicoreImageGen/bin/MulticoreImageGen
fi
if [ ! -f $multigen ]
then
	echo "Missing multigen!"
	echo     "Not found in default location: \$PDK_INSTALL_PATH/ti/boot/sbl/tools/multicoreImageGen/bin/MulticoreImageGen"
	echo     "Override default location by setting MULTICOREIMAGEGEN, eg:"
	echo         "export MULTICOREIMAGEGEN=$PDK_INSTALL_PATH/ti/boot/sbl/tools/multicoreImageGen/bin/MulticoreImageGen"
	exit
else
	echo Using multigen: $multigen
fi

sd_dir=$benchmarkdir/prebuilt-binaries/bootimages/$board

mkdir -p $sd_dir
outfiles=$benchmarkdir/prebuilt-binaries/*.out
for out in $outfiles
do
	echo Parsing $out ...
	name=${out##*/}
	name=${name%%_*out}
	rprc=$sd_dir/${name}_rprc
	mono $out2rprc $out $rprc
       echo  $multigen LE 55 $sd_dir/${name}_app $core_id $rprc
	rm $rprc
done

cp $sbl_sd $sd_dir


echo "Done! Check $sd_dir for images to put onto SD card."
